/* Tabela BASECALCTPOPER: Imposto */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela BASECALCTPOPER */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela BASECALCTPOPER,
             utilizando a tabela Geral de Logs de Operaes */
             
CREATE OR REPLACE TRIGGER LOG_FIS_BASECALCTPOPER
AFTER DELETE OR INSERT OR UPDATE
ON BASECALCTPOPER FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(300);
  V_DTOPER    DATE;
  V_IDTIPO    VARCHAR2(1);

BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN
      IF :OLD.CDIMPOSTO  IS NOT NULL THEN
         V_DESC := V_DESC || 'CodImpost=' || :OLD.CDIMPOSTO ;
      END IF;

      IF :OLD.NRSEQBCALTPOP IS NOT NULL THEN
         V_DESC := V_DESC || ' NumSeqBaseCalc=' || :OLD.NRSEQBCALTPOP;
      END IF;

      IF :OLD.IDENTRSAIDOP IS NOT NULL THEN
         V_DESC := V_DESC || ' EntraSaid=' || :OLD.IDENTRSAIDOP;
      END IF;
        
      IF :OLD.CDTIPOOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' TipoOper=' || :OLD.CDTIPOOPER;
      END IF;

      IF :OLD.CDIMPOBCALC IS NOT NULL THEN
         V_DESC := V_DESC || ' ImpoBCalc=' || :OLD.CDIMPOBCALC;
      END IF;

      IF :OLD.CDCFOPIMPOTPOP IS NOT NULL THEN
         V_DESC := V_DESC || ' CFOPImpostOp=' || :OLD.CDCFOPIMPOTPOP;
      END IF;
      
      IF :OLD.CDCSTIMPOTPOP IS NOT NULL THEN	     
         V_DESC := V_DESC || ' CSTImpostOp=' || :OLD.CDCSTIMPOTPOP;
      END IF;

      IF :OLD.CDFISCIMPOTPOP IS NOT NULL THEN
         V_DESC := V_DESC || ' CodFiscImp='  || :OLD.CDFISCIMPOTPOP;
      END IF;

      V_TIPO := '3';
      V_ITPESQ := :OLD.CDIMPOSTO;
   ELSE
      IF UPDATING THEN
         IF (:NEW.CDIMPOSTO        <> :OLD.CDIMPOSTO)     OR
            (:NEW.NRSEQBCALTPOP    <> :OLD.NRSEQBCALTPOP) OR
            (:NEW.IDENTRSAIDOP     <> :OLD.IDENTRSAIDOP)  OR
            (:NEW.CDTIPOOPER       <> :OLD.CDTIPOOPER)    OR
            (:NEW.CDIMPOBCALC      <> :OLD.CDIMPOBCALC)   OR
            (:NEW.CDCFOPIMPOTPOP   <> :OLD.CDCFOPIMPOTPOP)OR
            (:NEW.CDCSTIMPOTPOP    <> :OLD.CDCSTIMPOTPOP) OR
            (:NEW.CDFISCIMPOTPOP   <> :OLD.CDFISCIMPOTPOP)THEN


            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDIMPOSTO;
         END IF;
      ELSE
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDIMPOSTO;
      END IF;

      IF :NEW.CDIMPOSTO IS NOT NULL THEN
         V_DESC := V_DESC || 'CodImpost=' || :NEW.CDIMPOSTO;
      END IF;
      
      IF :NEW.NRSEQBCALTPOP IS NOT NULL THEN
         V_DESC := V_DESC || ' NumSeqBaseCalc=' || :NEW.NRSEQBCALTPOP;
      END IF;

      IF :NEW.IDENTRSAIDOP IS NOT NULL THEN
         V_DESC := V_DESC || ' EntraSaid=' || :NEW.IDENTRSAIDOP;
      END IF;
        
      IF :NEW.CDTIPOOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' TipoOper=' || :NEW.CDTIPOOPER;
      END IF;

      IF :NEW.CDIMPOBCALC IS NOT NULL THEN
         V_DESC := V_DESC || ' ImpoBCalc=' || :NEW.CDIMPOBCALC;
      END IF;

      IF :NEW.CDCFOPIMPOTPOP IS NOT NULL THEN
         V_DESC := V_DESC || ' CFOPImpostOp=' || :NEW.CDCFOPIMPOTPOP;
      END IF;
      
      IF :NEW.CDCSTIMPOTPOP IS NOT NULL THEN
         V_DESC := V_DESC || ' CSTImpostOp=' || :NEW.CDCSTIMPOTPOP;
      END IF;

      IF :NEW.CDFISCIMPOTPOP IS NOT NULL THEN
         V_DESC := V_DESC || ' CodFiscImp='  || :NEW.CDFISCIMPOTPOP;
      END IF;
      
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('BASECALCTPOPER',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST,
                V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIS_BASECALCTPOPER ','5.25.000'); END;
/

