/******************************************************************************/
/* TEKNISA                                                                    */
/******************************************************************************/
/*                                                                            */
/* NOME: GRAVA_MOVOPSOL                                                       */
/*                                                                            */
/* DESCRIO:                                                                 */
/*   Grava log de ITEMSOLI                                                 */
/*                                                                            */
/* CRIAO:                                                                   */
/* 12/02/2004 - Luiz Otvio de Souza                                          */
/*                                                                            */
/******************************************************************************/

/*
@C:\WEB_410\Sql\End_Conv\Oracle\8770_SUPTRGO_GRAVA_MOVOPSOL.SQL
*/

CREATE OR REPLACE TRIGGER GRAVA_MOVOPSOL
AFTER INSERT OR UPDATE OR DELETE
ON ITEMSOLI FOR EACH ROW

DECLARE
   V_IDGRAVLOGSOL VARCHAR2(03);
   V_DSRDMUSUMOVS VARCHAR2(50);
   V_DSENDUSUMOVS VARCHAR2(50);
   V_DSNMUSUMOVS  VARCHAR2(50);
   V_DSMETUSUMOVS VARCHAR2(250);

   V_CDOPERADOR   OPERADOR.CDOPERADOR%TYPE;
BEGIN
   SELECT MAX(NVL(IDGRAVLOGSOL, 'SSS'))
   INTO V_IDGRAVLOGSOL
   FROM PARASUPRI
   WHERE (CDFILIAL = (SELECT NVL(CDFILCENTCMP, CDFILIAL)
                      FROM FILIAL
                      WHERE (CDFILIAL = NVL(:NEW.CDFILSOLI, :OLD.CDFILSOLI))));

   WEBTUNNING(V_DSENDUSUMOVS, V_DSNMUSUMOVS, V_DSRDMUSUMOVS, V_DSMETUSUMOVS, V_CDOPERADOR);

   IF V_DSRDMUSUMOVS = 'VIA BD' THEN
      IF INSERTING THEN
         IF SUBSTR(V_IDGRAVLOGSOL, 1, 1) = 'S' THEN
            INSERT INTO MOVOPSOL
            (CDFILSOLMOV, CDFILLANMOV, NRSOLIMOV, CDPRODUTO, DTENTROPER, DTOPERSOL, CDOPERADOR,
             DSJUSTOPER, QTANTOPER, QTDEPOPER, IDOPERAMOVS, DSRDMUSUMOVS, DSENDUSUMOVS,
             DSNMUSUMOVS, DSMETUSUMOVS)
            VALUES
            (:NEW.CDFILSOLI, :NEW.CDFILLAN, :NEW.NRSOLICMP, :NEW.CDPRODUTO, :NEW.DTPROGENTR, SYSDATE,
             NULL, 'VIA BD', 0, :NEW.QTSOLIPROD, 'I', V_DSRDMUSUMOVS, V_DSENDUSUMOVS, V_DSNMUSUMOVS,
             V_DSMETUSUMOVS);
         END IF;
      END IF;

      IF UPDATING THEN
         IF SUBSTR(V_IDGRAVLOGSOL, 2, 1) = 'S' THEN
            INSERT INTO MOVOPSOL
            (CDFILSOLMOV, CDFILLANMOV, NRSOLIMOV, CDPRODUTO, DTENTROPER, DTOPERSOL, CDOPERADOR,
             DSJUSTOPER, QTANTOPER, QTDEPOPER, IDOPERAMOVS, DSRDMUSUMOVS, DSENDUSUMOVS,
             DSNMUSUMOVS, DSMETUSUMOVS)
            VALUES
            (:OLD.CDFILSOLI, :OLD.CDFILLAN, :OLD.NRSOLICMP, :OLD.CDPRODUTO, :OLD.DTPROGENTR, SYSDATE,
             NULL, 'VIA BD', :OLD.QTSOLIPROD, :NEW.QTSOLIPROD, 'A', V_DSRDMUSUMOVS, V_DSENDUSUMOVS, V_DSNMUSUMOVS,
             V_DSMETUSUMOVS);
         END IF;
      END IF;

      IF DELETING THEN
         IF SUBSTR(V_IDGRAVLOGSOL, 3, 1) = 'S' THEN
            INSERT INTO MOVOPSOL
            (CDFILSOLMOV, CDFILLANMOV, NRSOLIMOV, CDPRODUTO, DTENTROPER, DTOPERSOL, CDOPERADOR,
             DSJUSTOPER, QTANTOPER, QTDEPOPER, IDOPERAMOVS, DSRDMUSUMOVS, DSENDUSUMOVS,
             DSNMUSUMOVS, DSMETUSUMOVS)
            VALUES
            (:OLD.CDFILSOLI, :OLD.CDFILLAN, :OLD.NRSOLICMP, :OLD.CDPRODUTO, :OLD.DTPROGENTR, SYSDATE,
             NULL, 'VIA BD', :OLD.QTSOLIPROD, 0, 'E', V_DSRDMUSUMOVS, V_DSENDUSUMOVS, V_DSNMUSUMOVS,
             V_DSMETUSUMOVS);
         END IF;
      END IF;
   END IF;
END;
/



-- VERSAO --
BEGIN ATUVEROBJ('GRAVA_MOVOPSOL','4.11.078'); END;
/

